/*
  Copyright 1999 Brian H. Trammell (brian@altara.org)

  This software (and its source code) are freely usable, modifiable,
  and redistributable under the terms of the GNU General Public License, 
  available at http://www.gnu.org/copyleft/gpl.html.

  Note this library software is NOT distributed under the GNU LGPL; if you 
  link an application with this software, it is ILLEGAL to distribute it
  under any terms incompatible with the GNU GPL.
*/

package org.altara.javalib;
import java.util.Vector;

/*
  This is a generic Queue, built atop a Vector.
*/

public class Queue extends Vector {
    

    /**
       Create a new Queue
       
       @return a new Queue
    */
    
    public Queue () {
    }
    
    /**
       Enqueue an object
       
       @param element the Object to enqueue
    */
    
    public synchronized void enqueue(Object element) {
	addElement(element);
    }

    /**
       Dequeue an object.

       @return the object that was at the tail of the queue, or NULL on empty.
    */

    public synchronized Object dequeue() {
	if (isEmpty())
	    return null;
	
	Object element = elementAt(0);
	removeElementAt(0);
	return element;
    }

    /**
       Peek at the tail object.

       @return the object at the tail of the queue, or NULL on empty.
    */

    public synchronized Object peek() {
	if (isEmpty())
	    return null;
	
	return elementAt(0);
    }

}





