/*
  Copyright 1999 Brian H. Trammell (brian@altara.org)
  Copyright 1999 Ben Parrott (benji@altara.org)
  
  This software (and its source code) are freely usable, modifiable, 
  and redistributable under the terms of the GNU General Public License, 
  available at http://www.gnu.org/copyleft/gpl.html, and in the ./COPYING 
  file in the MARS distribution.
*/

package org.altara.mars;


/**
   Probe subclass for checking the HTTP service at port 80
*/

// Revision 0.1: 26 Jan 1999 bht - initial entry
// Revision 0.3: 07 Feb 1999 bht - fixed javadoc 
// Revision 1.2.3 : 26 Mar 1999 contributed (Don Thorpe)
//                  - send host info in HTTP request for virtual hosts
// Revision 1.4.4 : 11 May 1999 bht - fixed the Bowers bug
//                                    Added user-agent reporting
// Revision 1.4.7 : 19 May 1999 bht - Made user-agent version reporting more
//                                    standard (MARS/1.x)

public class HTTPProbe extends Probe {

    /**
       Create an HTTPProbe for the specified host.

       @param host The Host to probe
       @return an HTTPProbe for the specified host
    */

  public HTTPProbe (Host host) {
       super(host,80,"HEAD / HTTP/1.0\nHost: " + host.getDNSName() + "\n" +
	  "User-agent: MARS/" + MARS.VERSION + "\n\n","200 OK");
  }
}
